=== clang-tools-extra/clangd/benchmarks/CompletionModel/CMakeLists.txt ===
add_benchmark(DecisionForestBenchmark DecisionForestBenchmark.cpp)

target_link_libraries(DecisionForestBenchmark
  PRIVATE
  clangDaemon
  LLVMSupport
  )
