=== libc/src/math/generic/CMakeLists.txt ===


add_entrypoint_object(
  canonicalize
  SRCS
    canonicalize.cpp
  HDRS
    ../canonicalize.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef
  SRCS
    canonicalizef.cpp
  HDRS
    ../canonicalizef.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef16
  SRCS
    canonicalizef16.cpp
  HDRS
    ../canonicalizef16.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef128
  SRCS
    canonicalizef128.cpp
  HDRS
    ../canonicalizef128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizel
  SRCS
    canonicalizel.cpp
  HDRS
    ../canonicalizel.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  iscanonical
  SRCS
    iscanonical.cpp
  HDRS
    ../iscanonical.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  iscanonicalf
  SRCS
    iscanonicalf.cpp
  HDRS
    ../iscanonicalf.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  iscanonicall
  SRCS
    iscanonicall.cpp
  HDRS
    ../iscanonicall.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  iscanonicalf16
  SRCS
    iscanonicalf16.cpp
  HDRS
    ../iscanonicalf16.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  iscanonicalf128
  SRCS
    iscanonicalf128.cpp
  HDRS
    ../iscanonicalf128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  ceil
  SRCS
    ceil.cpp
  HDRS
    ../ceil.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceilf
  SRCS
    ceilf.cpp
  HDRS
    ../ceilf.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceill
  SRCS
    ceill.cpp
  HDRS
    ../ceill.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
)

add_entrypoint_object(
  ceilf16
  SRCS
    ceilf16.cpp
  HDRS
    ../ceilf16.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.nearest_integer_operations
    libc.src.__support.macros.properties.cpu_features
    libc.src.__support.macros.properties.types
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceilf128
  SRCS
    ceilf128.cpp
  HDRS
    ../ceilf128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.nearest_integer_operations
)

add_entrypoint_object(
  daddl
  SRCS
    daddl.cpp
  HDRS
    ../daddl.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
)

add_entrypoint_object(
  daddf128
  SRCS
    daddf128.cpp
  HDRS
    ../daddf128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
 DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.add_sub
)

add_entrypoint_object(
  ddivl
  SRCS
    ddivl.cpp
  HDRS
    ../ddivl.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.generic.div
)

add_entrypoint_object(
  ddivf128
  SRCS
    ddivf128.cpp
  HDRS
    ../ddivf128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.div
)

add_entrypoint_object(
  dfmaf128
  SRCS
    dfmaf128.cpp
  HDRS
    ../dfmaf128.h
  DEPENDS
    libc.src.__support.FPUtil.fma
    libc.src.__support.macros.properties.types
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  dfmal
  SRCS
    dfmal.cpp
  HDRS
    ../dfmal.h
  DEPENDS
    libc.src.__support.FPUtil.fma
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  dsqrtl
  SRCS
    dsqrtl.cpp
  HDRS
    ../dsqrtl.h
  DEPENDS
    libc.src.__support.FPUtil.generic.sqrt
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  dsqrtf128
  SRCS
    dsqrtf128.cpp
  HDRS
    ../dsqrtf128.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.sqrt
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)


add_entrypoint_object(
  dsubf128
  SRCS
    dsubf128.cpp
  HDRS
    ../dsubf128.h
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
    libc.src.__support.macros.properties.types
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  dsubl
  SRCS
    dsubl.cpp
  HDRS
    ../dsubl.h
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_header_library(
  range_reduction
  HDRS
    range_reduction.h
    range_reduction_fma.h
  DEPENDS
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.common
)

add_header_library(
  range_reduction_double
  HDRS
    range_reduction_double_common.h
    range_reduction_double_fma.h
    range_reduction_double_nofma.h
  DEPENDS
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.common
    libc.src.__support.integer_literals
)

add_header_library(
  sincosf_utils
  HDRS
    sincosf_utils.h
  DEPENDS
    .range_reduction
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.common
)

add_header_library(
  sincosf16_utils
  HDRS
    sincosf16_utils.h
  DEPENDS
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.common
)

add_header_library(
  sincos_eval
  HDRS
    sincos_eval.h
  DEPENDS
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.integer_literals
)

add_entrypoint_object(
  cos
  SRCS
    cos.cpp
  HDRS
    ../cos.h
  DEPENDS
    .range_reduction_double
    .sincos_eval
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  cosf
  SRCS
    cosf.cpp
  HDRS
    ../cosf.h
  DEPENDS
    .sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  cosf16
  SRCS
    cosf16.cpp
  HDRS
    ../cosf16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  cospif
  SRCS
    cospif.cpp
  HDRS
    ../cospif.h
  DEPENDS
    .sincosf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  cospif16
  SRCS
    cospif16.cpp
  HDRS
    ../cospif16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sin
  SRCS
    sin.cpp
  HDRS
    ../sin.h
  DEPENDS
    .range_reduction_double
    .sincos_eval
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sinf
  SRCS
    sinf.cpp
  HDRS
    ../sinf.h
  DEPENDS
    .range_reduction
    .sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sinf16
  SRCS
    sinf16.cpp
  HDRS
    ../sinf16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
  COMPILE_OPTIONS
    -O3
)

add_entrypoint_object(
  sincos
  SRCS
    sincos.cpp
  HDRS
    ../sincos.h
  DEPENDS
    .range_reduction_double
    .sincos_eval
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sinpif
  SRCS
    sinpif.cpp
  HDRS
    ../sinpif.h
  DEPENDS
    .sincosf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.common
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sincosf
  SRCS
    sincosf.cpp
  HDRS
    ../sincosf.h
  DEPENDS
    .range_reduction
    .sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sinpif16
  SRCS
    sinpif16.cpp
  HDRS
    ../sinpif16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
